

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 SkyBlue
#property indicator_color3 Tomato

extern int Price = 0;
extern int Length = 9;
extern int Displace = 0;
extern int Filter = 0;
extern int Color = 0;
extern int ColorBarBack = 1;
extern double Deviation = 0.0;
double gd_108 = 4.0;
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
double g_ibuf_128[];
double g_ibuf_132[];

int init() {
   int li_unused_0 = 0;
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_116);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, g_ibuf_120);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, g_ibuf_124);
   SetIndexBuffer(3, g_ibuf_128);
   SetIndexBuffer(4, g_ibuf_132);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   string ls_4 = "SOFSIGNAL3(" + Length + ")";
   IndicatorShortName(ls_4);
   SetIndexLabel(0, "NLMA");
   SetIndexLabel(1, "Up");
   SetIndexLabel(2, "Dn");
   SetIndexShift(0, Displace);
   SetIndexShift(1, Displace);
   SetIndexShift(2, Displace);
   SetIndexDrawBegin(0, Length * gd_108 + Length);
   SetIndexDrawBegin(1, Length * gd_108 + Length);
   SetIndexDrawBegin(2, Length * gd_108 + Length);
   return (0);
}

int start() {
   int li_12;
   double ld_16;
   double ld_24;
   double ld_32;
   double ld_40;
   double ld_48;
   double ld_64;
   int l_ind_counted_8 = IndicatorCounted();
   double ld_72 = 3.1415926535;
   double ld_80 = 3.0 * ld_72;
   int li_88 = Length - 1;
   double ld_92 = Length * gd_108 + li_88;
   if (l_ind_counted_8 > 0) li_12 = Bars - l_ind_counted_8;
   if (l_ind_counted_8 < 0) return (0);
   if (l_ind_counted_8 == 0) li_12 = Bars - ld_92 - 1.0;
   if (l_ind_counted_8 < 1) {
      for (int l_index_0 = 1; l_index_0 < Length * gd_108 + Length; l_index_0++) {
         g_ibuf_116[Bars - l_index_0] = 0;
         g_ibuf_120[Bars - l_index_0] = 0;
         g_ibuf_124[Bars - l_index_0] = 0;
      }
   }
   for (int li_4 = li_12; li_4 >= 0; li_4--) {
      ld_48 = 0;
      ld_40 = 0;
      ld_32 = 0;
      for (l_index_0 = 0; l_index_0 <= ld_92 - 1.0; l_index_0++) {
         ld_64 = 1.0 / (ld_80 * ld_32 + 1.0);
         if (ld_32 <= 0.5) ld_64 = 1;
         ld_24 = MathCos(ld_72 * ld_32);
         ld_16 = ld_64 * ld_24;
         g_ibuf_128[l_index_0] = iMA(NULL, 0, 1, 0, MODE_SMA, Price, li_4 + l_index_0);
         ld_40 += ld_16 * g_ibuf_128[l_index_0];
         ld_48 += ld_16;
         if (ld_32 < 1.0) ld_32 += 1.0 / (li_88 - 1);
         else
            if (ld_32 < ld_92 - 1.0) ld_32 += (2.0 * gd_108 - 1.0) / (gd_108 * Length - 1.0);
      }
      if (ld_48 > 0.0) g_ibuf_116[li_4] = (Deviation / 100.0 + 1.0) * ld_40 / ld_48;
      if (Filter > 0)
         if (MathAbs(g_ibuf_116[li_4] - (g_ibuf_116[li_4 + 1])) < Filter * Point) g_ibuf_116[li_4] = g_ibuf_116[li_4 + 1];
      if (Color > 0) {
         g_ibuf_132[li_4] = g_ibuf_132[li_4 + 1];
         if (g_ibuf_116[li_4] - (g_ibuf_116[li_4 + 1]) > Filter * Point) g_ibuf_132[li_4] = 1;
         if (g_ibuf_116[li_4 + 1] - g_ibuf_116[li_4] > Filter * Point) g_ibuf_132[li_4] = -1;
         if (g_ibuf_132[li_4] > 0.0) {
            g_ibuf_120[li_4] = g_ibuf_116[li_4];
            if (g_ibuf_132[li_4 + ColorBarBack] < 0.0) g_ibuf_120[li_4 + ColorBarBack] = g_ibuf_116[li_4 + ColorBarBack];
            g_ibuf_124[li_4] = EMPTY_VALUE;
         }
         if (g_ibuf_132[li_4] < 0.0) {
            g_ibuf_124[li_4] = g_ibuf_116[li_4];
            if (g_ibuf_132[li_4 + ColorBarBack] > 0.0) g_ibuf_124[li_4 + ColorBarBack] = g_ibuf_116[li_4 + ColorBarBack];
            g_ibuf_120[li_4] = EMPTY_VALUE;
         }
      }
   }
   return (0);
}